'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('react/jsx-runtime');
var LexicalComposer = require('@lexical/react/LexicalComposer');
var LexicalRichTextPlugin = require('@lexical/react/LexicalRichTextPlugin');
var LexicalContentEditable = require('@lexical/react/LexicalContentEditable');
var LexicalHistoryPlugin = require('@lexical/react/LexicalHistoryPlugin');
var LexicalAutoFocusPlugin = require('@lexical/react/LexicalAutoFocusPlugin');
var LexicalErrorBoundary = require('@lexical/react/LexicalErrorBoundary');
var LexicalComposerContext = require('@lexical/react/LexicalComposerContext');
var React = require('react');
var lexical = require('lexical');
var link = require('@lexical/link');
var selection = require('@lexical/selection');
var utils = require('@lexical/utils');
var list = require('@lexical/list');
var reactDom = require('react-dom');
var richText = require('@lexical/rich-text');
var code = require('@lexical/code');
var ui = require('@cpchain-foundation/ui');
var Skeleton = require('react-loading-skeleton');
var table = require('@lexical/table');
var LexicalLinkPlugin = require('@lexical/react/LexicalLinkPlugin');
var LexicalListPlugin = require('@lexical/react/LexicalListPlugin');
var LexicalMarkdownShortcutPlugin = require('@lexical/react/LexicalMarkdownShortcutPlugin');
var markdown = require('@lexical/markdown');
var LexicalOnChangePlugin = require('@lexical/react/LexicalOnChangePlugin');
var LexicalAutoLinkPlugin = require('@lexical/react/LexicalAutoLinkPlugin');
var html = require('@lexical/html');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var LexicalErrorBoundary__default = /*#__PURE__*/_interopDefaultLegacy(LexicalErrorBoundary);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var Skeleton__default = /*#__PURE__*/_interopDefaultLegacy(Skeleton);

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "body {\n  margin: 0;\n  background: #eee;\n  font-family: system-ui, -apple-system, BlinkMacSystemFont, \".SFNSText-Regular\",\n    sans-serif;\n  font-weight: 500;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.other h2 {\n  font-size: 18px;\n  color: #444;\n  margin-bottom: 7px;\n}\n\n.other a {\n  color: #777;\n  text-decoration: underline;\n  font-size: 14px;\n}\n\n.other ul {\n  padding: 0;\n  margin: 0;\n  list-style-type: none;\n}\n\n.App {\n  font-family: sans-serif;\n  text-align: center;\n}\n\nh1 {\n  font-size: 24px;\n  color: #333;\n}\n\n.ltr {\n  text-align: left;\n}\n\n.rtl {\n  text-align: right;\n}\n\n.editor-container {\n  position: static !important;\n  margin: 20px auto 20px auto;\n  border-radius: 2px;\n  width: 80%;\n  color: #000;\n  position: relative;\n  line-height: 20px;\n  font-weight: 400;\n  text-align: left;\n  border-top-left-radius: 10px;\n  border-top-right-radius: 10px;\n}\n\n.editor-viewer {\n  margin: 20px auto 20px auto;\n  border-radius: 2px;\n  width: 80%;\n  color: #000;\n  position: relative;\n  line-height: 20px;\n  font-weight: 400;\n  text-align: left;\n  border-top-left-radius: 10px;\n  border-top-right-radius: 10px;\n  /* background: #fff; */\n}\n\n.editor-inner {\n  background: #fff;\n  position: relative;\n  min-height: 60vh;\n}\n\n.editor-inner h1 {\n  /* h1 不在编辑器内部显示 */\n  display: none;\n}\n\n\n.editor-input {\n  min-height: 150px;\n  resize: none;\n  font-size: 15px;\n  caret-color: rgb(5, 5, 5);\n  position: relative;\n  -moz-tab-size: 1;\n    -o-tab-size: 1;\n       tab-size: 1;\n  outline: 0;\n  padding: 15px 10px;\n  caret-color: #444;\n}\n\n.editor-placeholder {\n  color: #999;\n  overflow: hidden;\n  position: absolute;\n  text-overflow: ellipsis;\n  top: 15px;\n  left: 10px;\n  font-size: 15px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  display: inline-block;\n  pointer-events: none;\n}\n\n.editor-text-bold {\n  font-weight: bold;\n}\n\n.editor-text-italic {\n  font-style: italic;\n}\n\n.editor-text-underline {\n  text-decoration: underline;\n}\n\n.editor-text-strikethrough {\n  text-decoration: line-through;\n}\n\n.editor-text-underlineStrikethrough {\n  text-decoration: underline line-through;\n}\n\n.editor-text-code {\n  background-color: rgb(240, 242, 245);\n  padding: 1px 0.25rem;\n  font-family: Menlo, Consolas, Monaco, monospace;\n  font-size: 94%;\n}\n\n.editor-link {\n  color: rgb(33, 111, 219);\n  text-decoration: none;\n}\n\n.tree-view-output {\n  display: block;\n  background: #222;\n  color: #fff;\n  padding: 5px;\n  font-size: 12px;\n  white-space: pre-wrap;\n  margin: 1px auto 10px auto;\n  max-height: 250px;\n  position: relative;\n  border-bottom-left-radius: 10px;\n  border-bottom-right-radius: 10px;\n  overflow: auto;\n  line-height: 14px;\n}\n\n.editor-code {\n  background-color: rgb(240, 242, 245);\n  font-family: Menlo, Consolas, Monaco, monospace;\n  display: block;\n  padding: 8px 8px 8px 52px;\n  line-height: 1.53;\n  font-size: 13px;\n  margin: 0;\n  margin-top: 8px;\n  margin-bottom: 8px;\n  -moz-tab-size: 2;\n    -o-tab-size: 2;\n       tab-size: 2;\n  /* white-space: pre; */\n  overflow-x: auto;\n  position: relative;\n}\n\n.editor-code:before {\n  content: attr(data-gutter);\n  position: absolute;\n  background-color: #eee;\n  left: 0;\n  top: 0;\n  border-right: 1px solid #ccc;\n  padding: 8px;\n  color: #777;\n  white-space: pre-wrap;\n  text-align: right;\n  min-width: 25px;\n}\n\n.editor-code:after {\n  content: attr(data-highlight-language);\n  top: 0;\n  right: 3px;\n  padding: 3px;\n  font-size: 10px;\n  text-transform: uppercase;\n  position: absolute;\n  color: rgba(0, 0, 0, 0.5);\n}\n\n.editor-tokenComment {\n  color: slategray;\n}\n\n.editor-tokenPunctuation {\n  color: #999;\n}\n\n.editor-tokenProperty {\n  color: #905;\n}\n\n.editor-tokenSelector {\n  color: #690;\n}\n\n.editor-tokenOperator {\n  color: #9a6e3a;\n}\n\n.editor-tokenAttr {\n  color: #07a;\n}\n\n.editor-tokenVariable {\n  color: #e90;\n}\n\n.editor-tokenFunction {\n  color: #dd4a68;\n}\n\n.editor-paragraph {\n  margin: 0;\n  margin-bottom: 8px;\n  position: relative;\n}\n\n.editor-paragraph:last-child {\n  margin-bottom: 0;\n}\n\n.editor-heading-h1 {\n  font-size: 24px;\n  color: rgb(5, 5, 5);\n  font-weight: 400;\n  margin: 0;\n  margin-bottom: 12px;\n  padding: 0;\n}\n\n.editor-heading-h2 {\n  font-size: 15px;\n  color: rgb(101, 103, 107);\n  font-weight: 700;\n  margin: 0;\n  margin-top: 10px;\n  padding: 0;\n  text-transform: uppercase;\n}\n\n.editor-quote {\n  margin: 0;\n  margin-left: 20px;\n  font-size: 15px;\n  color: rgb(101, 103, 107);\n  border-left-color: rgb(206, 208, 212);\n  border-left-width: 4px;\n  border-left-style: solid;\n  padding-left: 16px;\n}\n\n.editor-list-ol {\n  padding: 0;\n  margin: 0;\n  margin-left: 16px;\n}\n\n.editor-list-ul {\n  padding: 0;\n  margin: 0;\n  margin-left: 16px;\n}\n\n.editor-listitem {\n  margin: 8px 32px 8px 32px;\n}\n\n.editor-nested-listitem {\n  list-style-type: none;\n}\n\npre::-webkit-scrollbar {\n  background: transparent;\n  width: 10px;\n}\n\npre::-webkit-scrollbar-thumb {\n  background: #999;\n}\n\n.debug-timetravel-panel {\n  overflow: hidden;\n  padding: 0 0 10px 0;\n  margin: auto;\n  display: flex;\n}\n\n.debug-timetravel-panel-slider {\n  padding: 0;\n  flex: 8;\n}\n\n.debug-timetravel-panel-button {\n  padding: 0;\n  border: 0;\n  background: none;\n  flex: 1;\n  color: #fff;\n  font-size: 12px;\n}\n\n.debug-timetravel-panel-button:hover {\n  text-decoration: underline;\n}\n\n.debug-timetravel-button {\n  border: 0;\n  padding: 0;\n  font-size: 12px;\n  top: 10px;\n  right: 15px;\n  position: absolute;\n  background: none;\n  color: #fff;\n}\n\n.debug-timetravel-button:hover {\n  text-decoration: underline;\n}\n\n.emoji {\n  color: transparent;\n  background-size: 16px 16px;\n  background-position: center;\n  background-repeat: no-repeat;\n  vertical-align: middle;\n  margin: 0 -1px;\n}\n\n.emoji-inner {\n  padding: 0 0.15em;\n}\n\n.emoji-inner::-moz-selection {\n  color: transparent;\n  background-color: rgba(150, 150, 150, 0.4);\n}\n\n.emoji-inner::selection {\n  color: transparent;\n  background-color: rgba(150, 150, 150, 0.4);\n}\n\n.emoji-inner::moz-selection {\n  color: transparent;\n  background-color: rgba(150, 150, 150, 0.4);\n}\n\n.toolbar {\n  display: flex;\n  margin-bottom: 1px;\n  background: #fff;\n  padding: 4px;\n  border-top-left-radius: 10px;\n  border-top-right-radius: 10px;\n  vertical-align: middle;\n}\n\n.toolbar button.toolbar-item {\n  border: 0;\n  display: flex;\n  background: none;\n  border-radius: 10px;\n  padding: 8px;\n  cursor: pointer;\n  vertical-align: middle;\n}\n\n.toolbar button.toolbar-item:disabled {\n  cursor: not-allowed;\n}\n\n.toolbar button.toolbar-item.spaced {\n  margin-right: 2px;\n}\n\n.toolbar button.toolbar-item i.format {\n  background-size: contain;\n  display: inline-block;\n  height: 18px;\n  width: 18px;\n  margin-top: 2px;\n  vertical-align: -0.25em;\n  display: flex;\n  opacity: 0.6;\n}\n\n.toolbar button.toolbar-item:disabled i.format {\n  opacity: 0.2;\n}\n\n.toolbar button.toolbar-item.active {\n  background-color: rgba(223, 232, 250, 0.3);\n}\n\n.toolbar button.toolbar-item.active i {\n  opacity: 1;\n}\n\n.toolbar .toolbar-item:hover:not([disabled]) {\n  background-color: #eee;\n}\n\n.toolbar .divider {\n  width: 1px;\n  background-color: #eee;\n  margin: 0 4px;\n}\n\n.toolbar select.toolbar-item {\n  border: 0;\n  display: flex;\n  background: none;\n  border-radius: 10px;\n  padding: 8px;\n  vertical-align: middle;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  width: 70px;\n  font-size: 14px;\n  color: #777;\n  text-overflow: ellipsis;\n}\n\n.toolbar select.code-language {\n  text-transform: capitalize;\n  width: 130px;\n}\n\n.toolbar .toolbar-item .text {\n  display: flex;\n  line-height: 20px;\n  width: 200px;\n  vertical-align: middle;\n  font-size: 14px;\n  color: #777;\n  text-overflow: ellipsis;\n  width: 70px;\n  overflow: hidden;\n  height: 20px;\n  text-align: left;\n}\n\n.toolbar .toolbar-item .icon {\n  display: flex;\n  width: 20px;\n  height: 20px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  margin-right: 8px;\n  line-height: 16px;\n  background-size: contain;\n}\n\n.toolbar i.chevron-down {\n  margin-top: 3px;\n  width: 16px;\n  height: 16px;\n  display: flex;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\n.toolbar i.chevron-down.inside {\n  width: 16px;\n  height: 16px;\n  display: flex;\n  margin-left: -25px;\n  margin-top: 11px;\n  margin-right: 10px;\n  pointer-events: none;\n}\n\ni.chevron-down {\n  background-color: transparent;\n  background-size: contain;\n  display: inline-block;\n  height: 8px;\n  width: 8px;\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-chevron-down\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z\"/></svg>');\n\n}\n\n#block-controls button:hover {\n  background-color: #efefef;\n}\n\n#block-controls button:focus-visible {\n  border-color: blue;\n}\n\n#block-controls span.block-type {\n  background-size: contain;\n  display: block;\n  width: 18px;\n  height: 18px;\n  margin: 2px;\n}\n\n#block-controls span.block-type.paragraph {\n  background-image: url(images/icons/text-paragraph.svg);\n}\n\n#block-controls span.block-type.h1 {\n  background-image: url(images/icons/type-h1.svg);\n}\n\n#block-controls span.block-type.h2 {\n  background-image: url(images/icons/type-h2.svg);\n}\n\n#block-controls span.block-type.quote {\n  background-image: url(images/icons/chat-square-quote.svg);\n}\n\n#block-controls span.block-type.ul {\n  background-image: url(images/icons/list-ul.svg);\n}\n\n#block-controls span.block-type.ol {\n  background-image: url(images/icons/list-ol.svg);\n}\n\n#block-controls span.block-type.code {\n  background-image: url(images/icons/code.svg);\n}\n\n.dropdown {\n  z-index: 5;\n  display: block;\n  position: absolute;\n  box-shadow: 0 12px 28px 0 rgba(0, 0, 0, 0.2), 0 2px 4px 0 rgba(0, 0, 0, 0.1),\n    inset 0 0 0 1px rgba(255, 255, 255, 0.5);\n  border-radius: 8px;\n  min-width: 100px;\n  min-height: 40px;\n  background-color: #fff;\n}\n\n.dropdown .item {\n  margin: 0 8px 0 8px;\n  padding: 8px;\n  color: #050505;\n  cursor: pointer;\n  line-height: 16px;\n  font-size: 15px;\n  display: flex;\n  align-content: center;\n  flex-direction: row;\n  flex-shrink: 0;\n  justify-content: space-between;\n  background-color: #fff;\n  border-radius: 8px;\n  border: 0;\n  min-width: 268px;\n}\n\n.dropdown .item .active {\n  display: flex;\n  width: 20px;\n  height: 20px;\n  background-size: contain;\n}\n\n.dropdown .item:first-child {\n  margin-top: 8px;\n}\n\n.dropdown .item:last-child {\n  margin-bottom: 8px;\n}\n\n.dropdown .item:hover {\n  background-color: #eee;\n}\n\n.dropdown .item .text {\n  display: flex;\n  line-height: 20px;\n  flex-grow: 1;\n  width: 200px;\n}\n\n.dropdown .item .icon {\n  display: flex;\n  width: 20px;\n  height: 20px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  margin-right: 12px;\n  line-height: 16px;\n  background-size: contain;\n}\n\n.link-editor {\n  position: absolute;\n  z-index: 100;\n  top: -10000px;\n  left: -10000px;\n  margin-top: -6px;\n  max-width: 300px;\n  width: 100%;\n  opacity: 0;\n  background-color: #fff;\n  box-shadow: 0px 5px 10px rgba(0, 0, 0, 0.3);\n  border-radius: 8px;\n  transition: opacity 0.5s;\n}\n\n.link-editor .link-input {\n  display: block;\n  width: calc(100% - 24px);\n  box-sizing: border-box;\n  margin: 8px 12px;\n  padding: 8px 12px;\n  border-radius: 15px;\n  background-color: #eee;\n  font-size: 15px;\n  color: rgb(5, 5, 5);\n  border: 0;\n  outline: 0;\n  position: relative;\n  font-family: inherit;\n}\n\n.link-editor div.link-edit {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-chevron-down\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z\"/></svg>');\n\n  background-size: 16px;\n  background-position: center;\n  background-repeat: no-repeat;\n  width: 35px;\n  vertical-align: -0.25em;\n  position: absolute;\n  right: 0;\n  top: 0;\n  bottom: 0;\n  cursor: pointer;\n}\n\n.link-editor .link-input a {\n  color: rgb(33, 111, 219);\n  text-decoration: none;\n  display: block;\n  white-space: nowrap;\n  overflow: hidden;\n  margin-right: 30px;\n  text-overflow: ellipsis;\n}\n\n.link-editor .link-input a:hover {\n  text-decoration: underline;\n}\n\n.link-editor .button {\n  width: 20px;\n  height: 20px;\n  display: inline-block;\n  padding: 6px;\n  border-radius: 8px;\n  cursor: pointer;\n  margin: 0 2px;\n}\n\n.link-editor .button.hovered {\n  width: 20px;\n  height: 20px;\n  display: inline-block;\n  background-color: #eee;\n}\n\n.link-editor .button i,\n.actions i {\n  background-size: contain;\n  display: inline-block;\n  height: 20px;\n  width: 20px;\n  vertical-align: -0.25em;\n}\n\ni.undo {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-arrow-counterclockwise\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M8 3a5 5 0 1 1-4.546 2.914.5.5 0 0 0-.908-.417A6 6 0 1 0 8 2v1z\"/><path d=\"M8 4.466V.534a.25.25 0 0 0-.41-.192L5.23 2.308a.25.25 0 0 0 0 .384l2.36 1.966A.25.25 0 0 0 8 4.466z\"/></svg>');\n  /* background-image: url(images/icons/arrow-counterclockwise.svg); */\n}\n\ni.redo {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-arrow-clockwise\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M8 3a5 5 0 1 0 4.546 2.914.5.5 0 0 1 .908-.417A6 6 0 1 1 8 2v1z\"/><path d=\"M8 4.466V.534a.25.25 0 0 1 .41-.192l2.36 1.966c.12.1.12.284 0 .384L8.41 4.658A.25.25 0 0 1 8 4.466z\"/></svg>');\n  /* background-image: url(images/icons/arrow-clockwise.svg); */\n}\n\n.icon.paragraph {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-text-paragraph\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M2 12.5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm4-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/text-paragraph.svg); */\n}\n\n.icon.large-heading,\n.icon.h1 {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-h1\" viewBox=\"0 0 16 16\"><path d=\"M8.637 13V3.669H7.379V7.62H2.758V3.67H1.5V13h1.258V8.728h4.62V13h1.259zm5.329 0V3.669h-1.244L10.5 5.316v1.265l2.16-1.565h.062V13h1.244z\"/></svg>');\n  /* background-image: url(images/icons/type-h1.svg); */\n}\n\n.icon.small-heading,\n.icon.h2 {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-h2\" viewBox=\"0 0 16 16\"><path d=\"M7.638 13V3.669H6.38V7.62H1.759V3.67H.5V13h1.258V8.728h4.62V13h1.259zm3.022-6.733v-.048c0-.889.63-1.668 1.716-1.668.957 0 1.675.608 1.675 1.572 0 .855-.554 1.504-1.067 2.085l-3.513 3.999V13H15.5v-1.094h-4.245v-.075l2.481-2.844c.875-.998 1.586-1.784 1.586-2.953 0-1.463-1.155-2.556-2.919-2.556-1.941 0-2.966 1.326-2.966 2.74v.049h1.223z\"/></svg>');\n  /* background-image: url(images/icons/type-h2.svg); */\n}\n\n.icon.bullet-list,\n.icon.ul {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-list-ul\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M5 11.5a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm-3 1a1 1 0 1 0 0-2 1 1 0 0 0 0 2zm0 4a1 1 0 1 0 0-2 1 1 0 0 0 0 2zm0 4a1 1 0 1 0 0-2 1 1 0 0 0 0 2z\"/></svg>');\n  /* background-image: url(images/icons/list-ul.svg); */\n}\n\n.icon.numbered-list,\n.icon.ol {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-list-ol\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M5 11.5a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5z\"/><path d=\"M1.713 11.865v-.474H2c.217 0 .363-.137.363-.317 0-.185-.158-.31-.361-.31-.223 0-.367.152-.373.31h-.59c.016-.467.373-.787.986-.787.588-.002.954.291.957.703a.595.595 0 0 1-.492.594v.033a.615.615 0 0 1 .569.631c.003.533-.502.8-1.051.8-.656 0-1-.37-1.008-.794h.582c.008.178.186.306.422.309.254 0 .424-.145.422-.35-.002-.195-.155-.348-.414-.348h-.3zm-.004-4.699h-.604v-.035c0-.408.295-.844.958-.844.583 0 .96.326.96.756 0 .389-.257.617-.476.848l-.537.572v.03h1.054V9H1.143v-.395l.957-.99c.138-.142.293-.304.293-.508 0-.18-.147-.32-.342-.32a.33.33 0 0 0-.342.338v.041zM2.564 5h-.635V2.924h-.031l-.598.42v-.567l.629-.443h.635V5z\"/></svg>');\n  /* background-image: url(images/icons/list-ol.svg); */\n}\n\n.icon.quote {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-chat-square-quote\" viewBox=\"0 0 16 16\"><path d=\"M14 1a1 1 0 0 1 1 1v8a1 1 0 0 1-1 1h-2.5a2 2 0 0 0-1.6.8L8 14.333 6.1 11.8a2 2 0 0 0-1.6-.8H2a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1h12zM2 0a2 2 0 0 0-2 2v8a2 2 0 0 0 2 2h2.5a1 1 0 0 1 .8.4l1.9 2.533a1 1 0 0 0 1.6 0l1.9-2.533a1 1 0 0 1 .8-.4H14a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z\"/><path d=\"M7.066 4.76A1.665 1.665 0 0 0 4 5.668a1.667 1.667 0 0 0 2.561 1.406c-.131.389-.375.804-.777 1.22a.417.417 0 1 0 .6.58c1.486-1.54 1.293-3.214.682-4.112zm4 0A1.665 1.665 0 0 0 8 5.668a1.667 1.667 0 0 0 2.561 1.406c-.131.389-.375.804-.777 1.22a.417.417 0 1 0 .6.58c1.486-1.54 1.293-3.214.682-4.112z\"/></svg>');\n  /* background-image: url(images/icons/chat-square-quote.svg); */\n}\n\n.icon.code {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-code\" viewBox=\"0 0 16 16\"><path d=\"M5.854 4.854a.5.5 0 1 0-.708-.708l-3.5 3.5a.5.5 0 0 0 0 .708l3.5 3.5a.5.5 0 0 0 .708-.708L2.707 8l3.147-3.146zm4.292 0a.5.5 0 0 1 .708-.708l3.5 3.5a.5.5 0 0 1 0 .708l-3.5 3.5a.5.5 0 0 1-.708-.708L13.293 8l-3.147-3.146z\"/></svg>');\n  /* background-image: url(images/icons/code.svg); */\n}\n\ni.bold {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-bold\" viewBox=\"0 0 16 16\"><path d=\"M8.21 13c2.106 0 3.412-1.087 3.412-2.823 0-1.306-.984-2.283-2.324-2.386v-.055a2.176 2.176 0 0 0 1.852-2.14c0-1.51-1.162-2.46-3.014-2.46H3.843V13H8.21zM5.908 4.674h1.696c.963 0 1.517.451 1.517 1.244 0 .834-.629 1.32-1.73 1.32H5.908V4.673zm0 6.788V8.598h1.73c1.217 0 1.88.492 1.88 1.415 0 .943-.643 1.449-1.832 1.449H5.907z\"/></svg>');\n  /* background-image: url(images/icons/type-bold.svg); */\n}\n\ni.italic {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-italic\" viewBox=\"0 0 16 16\"><path d=\"M7.991 11.674 9.53 4.455c.123-.595.246-.71 1.347-.807l.11-.52H7.211l-.11.52c1.06.096 1.128.212 1.005.807L6.57 11.674c-.123.595-.246.71-1.346.806l-.11.52h3.774l.11-.52c-1.06-.095-1.129-.211-1.006-.806z\"/></svg>');\n  /* background-image: url(images/icons/type-italic.svg); */\n}\n\ni.underline {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-underline\" viewBox=\"0 0 16 16\"><path d=\"M5.313 3.136h-1.23V9.54c0 2.105 1.47 3.623 3.917 3.623s3.917-1.518 3.917-3.623V3.136h-1.23v6.323c0 1.49-.978 2.57-2.687 2.57-1.709 0-2.687-1.08-2.687-2.57V3.136zM12.5 15h-9v-1h9v1z\"/></svg>');\n  /* background-image: url(images/icons/type-underline.svg); */\n}\n\ni.strikethrough {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-strikethrough\" viewBox=\"0 0 16 16\"><path d=\"M6.333 5.686c0 .31.083.581.27.814H5.166a2.776 2.776 0 0 1-.099-.76c0-1.627 1.436-2.768 3.48-2.768 1.969 0 3.39 1.175 3.445 2.85h-1.23c-.11-1.08-.964-1.743-2.25-1.743-1.23 0-2.18.602-2.18 1.607zm2.194 7.478c-2.153 0-3.589-1.107-3.705-2.81h1.23c.144 1.06 1.129 1.703 2.544 1.703 1.34 0 2.31-.705 2.31-1.675 0-.827-.547-1.374-1.914-1.675L8.046 8.5H1v-1h14v1h-3.504c.468.437.675.994.675 1.697 0 1.826-1.436 2.967-3.644 2.967z\"/></svg>');\n  /* background-image: url(images/icons/type-strikethrough.svg); */\n}\n\ni.code {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-code\" viewBox=\"0 0 16 16\"><path d=\"M5.854 4.854a.5.5 0 1 0-.708-.708l-3.5 3.5a.5.5 0 0 0 0 .708l3.5 3.5a.5.5 0 0 0 .708-.708L2.707 8l3.147-3.146zm4.292 0a.5.5 0 0 1 .708-.708l3.5 3.5a.5.5 0 0 1 0 .708l-3.5 3.5a.5.5 0 0 1-.708-.708L13.293 8l-3.147-3.146z\"/></svg>');\n  /* background-image: url(images/icons/code.svg); */\n}\n\ni.link {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-link\" viewBox=\"0 0 16 16\"><path d=\"M6.354 5.5H4a3 3 0 0 0 0 6h3a3 3 0 0 0 2.83-4H9c-.086 0-.17.01-.25.031A2 2 0 0 1 7 10.5H4a2 2 0 1 1 0-4h1.535c.218-.376.495-.714.82-1z\"/><path d=\"M9 5.5a3 3 0 0 0-2.83 4h1.098A2 2 0 0 1 9 6.5h3a2 2 0 1 1 0 4h-1.535a4.02 4.02 0 0 1-.82 1H12a3 3 0 1 0 0-6H9z\"/></svg>');\n  /* background-image: url(images/icons/link.svg); */\n}\n\ni.left-align {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-text-left\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M2 12.5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/text-left.svg); */\n}\n\ni.center-align {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-text-center\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M4 12.5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm-2-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm2-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm-2-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/text-center.svg); */\n}\n\ni.right-align {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-text-right\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M6 12.5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm-4-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm4-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm-4-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/text-right.svg); */\n}\n\ni.justify-align {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-justify\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M2 12.5a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/justify.svg); */\n}\n\n.editor-list-ol {\n  list-style-type: decimal !important;\n}\n\n.editor-list-ul {\n  list-style-type: disc !important;\n}\n\ni.video {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-file-play\" viewBox=\"0 0 16 16\"><path d=\"M6 10.117V5.883a.5.5 0 0 1 .757-.429l3.528 2.117a.5.5 0 0 1 0 .858l-3.528 2.117a.5.5 0 0 1-.757-.43z\"/><path d=\"M4 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H4zm0 1h8a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1H4a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1z\"/></svg>');\n  /* background-image: url(images/icons/video.svg); */\n}\n\ni.image {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-file-earmark-image\" viewBox=\"0 0 16 16\"><path d=\"M6.502 7a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3z\"/><path d=\"M14 14a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V2a2 2 0 0 1 2-2h5.5L14 4.5V14zM4 1a1 1 0 0 0-1 1v10l2.224-2.224a.5.5 0 0 1 .61-.075L8 11l2.157-3.02a.5.5 0 0 1 .76-.063L13 10V4.5h-2A1.5 1.5 0 0 1 9.5 3V1H4z\"/></svg>');\n  /* background-image: url(images/icons/image.svg); */\n}\n\n.editor-img {\n  /* background:url(images/icons/img-holder.svg) no-repeat scroll 0 0;  */\n}\n\n.changes_add span{\n  background-color: rgba(0, 255, 0, 0.2) !important;\n  text-decoration: underline;\n}\n\n.changes_add div{\n  background-color: rgba(0, 255, 0, 0.2) !important;\n  text-decoration: underline;\n}\n\n.changes_add p{\n  background-color: rgba(0, 255, 0, 0.2) !important;\n  text-decoration: underline;\n}\n\n\n.changes_remove div{\n  background-color: rgba(255, 0, 0, 0.2) !important;\n  text-decoration: line-through;\n}\n\n.changes_remove span{\n  background-color: rgba(255, 0, 0, 0.2) !important;\n  text-decoration: line-through;\n}\n.changes_remove p{\n  background-color: rgba(255, 0, 0, 0.2) !important;\n  text-decoration: line-through;\n}\n\n.changes_add::before {\n  content: '+';\n  display: block;\n  margin-bottom: 8px; \n  margin-top: 8px;\n  font-size: 20px;\n}\n.changes_remove::before {\n  content: '-';\n  display: block;\n  margin-bottom: 8px; \n  margin-top: 8px;\n  font-size: 20px;\n}\n.changes_add::after {\n  content: '...';\n  display: block;\n  margin-bottom: 8px; \n  margin-top: 8px;\n  font-size: 20px;\n}\n.changes_remove::after {\n  content: '...';\n  display: block;\n  margin-bottom: 8px; \n  margin-top: 8px;\n  font-size: 20px;\n}\n\n.changes_section{\n  margin-top:  12px;\n  margin-bottom: 12px;\n}\n\n.changes_remove img {\n  background-color: rgba(255, 0, 0, 0.2) !important;\n  padding: 20px; \n}\n.changes_add img {\n  background-color: rgba(0, 255, 0, 0.2) !important;\n  padding: 20px; \n}";
styleInject(css_248z);

const exampleTheme = {
    ltr: "ltr",
    rtl: "rtl",
    placeholder: "editor-placeholder",
    paragraph: "editor-paragraph",
    quote: "editor-quote",
    heading: {
        h1: "editor-heading-h1",
        h2: "editor-heading-h2",
        h3: "editor-heading-h3",
        h4: "editor-heading-h4",
        h5: "editor-heading-h5"
    },
    list: {
        nested: {
            listitem: "editor-nested-listitem"
        },
        ol: "editor-list-ol",
        ul: "editor-list-ul",
        listitem: "editor-listitem"
    },
    image: "editor-image",
    link: "editor-link",
    text: {
        bold: "editor-text-bold",
        italic: "editor-text-italic",
        overflowed: "editor-text-overflowed",
        hashtag: "editor-text-hashtag",
        underline: "editor-text-underline",
        strikethrough: "editor-text-strikethrough",
        underlineStrikethrough: "editor-text-underlineStrikethrough",
        code: "editor-text-code"
    },
    code: "editor-code",
    codeHighlight: {
        atrule: "editor-tokenAttr",
        attr: "editor-tokenAttr",
        boolean: "editor-tokenProperty",
        builtin: "editor-tokenSelector",
        cdata: "editor-tokenComment",
        char: "editor-tokenSelector",
        class: "editor-tokenFunction",
        "class-name": "editor-tokenFunction",
        comment: "editor-tokenComment",
        constant: "editor-tokenProperty",
        deleted: "editor-tokenProperty",
        doctype: "editor-tokenComment",
        entity: "editor-tokenOperator",
        function: "editor-tokenFunction",
        important: "editor-tokenVariable",
        inserted: "editor-tokenSelector",
        keyword: "editor-tokenAttr",
        namespace: "editor-tokenVariable",
        number: "editor-tokenProperty",
        operator: "editor-tokenOperator",
        prolog: "editor-tokenComment",
        property: "editor-tokenProperty",
        punctuation: "editor-tokenPunctuation",
        regex: "editor-tokenVariable",
        selector: "editor-tokenSelector",
        string: "editor-tokenSelector",
        symbol: "editor-tokenProperty",
        tag: "editor-tokenProperty",
        url: "editor-tokenOperator",
        variable: "editor-tokenVariable"
    }
};

function convertImageElement(element) {
    const nodeName = element.nodeName.toLowerCase();
    let node = null;
    if (nodeName === 'img') {
        node = $createImageNode(element.src);
    }
    return { node };
}
class ImageNode extends lexical.ElementNode {
    static getType() {
        return 'image';
    }
    static clone(node) {
        return new ImageNode(node.__url, node.__key);
    }
    constructor(url, key) {
        super(key);
        this.__url = url;
    }
    createDOM(config) {
        const image = document.createElement('img');
        image.src = this.__url;
        image.classList.add('editor-img');
        return image;
    }
    updateDOM() {
        return false;
    }
    setURL(url) {
        const writable = this.getWritable();
        writable.__url = url;
    }
    static importDOM() {
        return {
            img: (node) => ({
                conversion: convertImageElement,
                priority: 0,
            }),
        };
    }
    exportDOM(editor) {
        const { element } = super.exportDOM(editor);
        if (element && this.isEmpty()) {
            element.append(document.createElement('br'));
        }
        if (element) {
            const formatType = this.getFormatType();
            element.style.textAlign = formatType;
            const direction = this.getDirection();
            if (direction) {
                element.dir = direction;
            }
        }
        return {
            element,
        };
    }
    insertNewAfter(selection, restoreSelection = true) {
        const newElement = lexical.$createParagraphNode();
        const direction = this.getDirection();
        newElement.setDirection(direction);
        this.insertAfter(newElement, restoreSelection);
        return newElement;
    }
    collapseAtStart() {
        const newElement = lexical.$createParagraphNode();
        const children = this.getChildren();
        children.forEach((child) => newElement.append(child));
        this.replace(newElement);
        return true;
    }
    extractWithChild() {
        return true;
    }
    exportJSON() {
        throw new Error("Method not implemented.");
    }
    static importJSON(_serializedNode) {
        throw new Error("Method not implemented.");
    }
}
function $createImageNode(url) {
    return new ImageNode(url);
}
const INSERT_IMAGE_COMMAND = lexical.createCommand('INSERT_IMAGE_COMMAND');

function convertVideoElement(element) {
    const nodeName = element.nodeName.toLowerCase();
    let node = null;
    if (nodeName === 'video') {
        node = $createVideoNode(element.src);
    }
    return { node };
}
class VideoNode extends lexical.ElementNode {
    static getType() {
        return 'video';
    }
    static clone(node) {
        return new VideoNode(node.__url, node.__key);
    }
    constructor(url, key) {
        super(key);
        this.__url = url;
    }
    createDOM(config) {
        const x = document.createElement('video');
        x.setAttribute("controls", "controls");
        x.setAttribute("src", this.__url);
        return x;
    }
    static importDOM() {
        return {
            video: (node) => ({
                conversion: convertVideoElement,
                priority: 0,
            }),
        };
    }
    updateDOM() {
        return false;
    }
    setURL(url) {
        const writable = this.getWritable();
        writable.__url = url;
    }
    exportJSON() {
        throw new Error("Method not implemented.");
    }
    static importJSON(_serializedNode) {
        throw new Error("Method not implemented.");
    }
}
function $createVideoNode(url) {
    return new VideoNode(url);
}
const INSERT_VIDEO_COMMAND = lexical.createCommand('INSERT_VIDEO_COMMAND');

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

function Image({ selected, src, onClick }) {
    return jsxRuntime.jsxs("div", { className: "my-4 relative shadow-md", children: [selected && jsxRuntime.jsx("i", { className: "icon-check-circle text-3xl text-green-500 absolute" }), jsxRuntime.jsx("img", { className: "w-40 object-contain ", onClick: () => { onClick(); }, src: src, alt: "" })] });
}
function ImageHolder() {
    return jsxRuntime.jsx("div", { className: "w-40 h-405", children: jsxRuntime.jsx(Skeleton__default["default"], { count: 5, className: "h-40 my-3" }) });
}
function ImageViewer({ images, onSelect, loading }) {
    const [img, setImg] = React.useState([]);
    const columns = [1, 2, 3, 4];
    React.useEffect(() => {
        setImg(images.map(p => { return { src: p, selected: false }; }));
    }, [images]);
    if (loading) {
        return jsxRuntime.jsx("div", { className: "w-224 h-96 overflow-y-auto flex-row flex overflow-hidden gap-4", children: columns.map((p) => jsxRuntime.jsx(ImageHolder, {}, p)) });
    }
    return jsxRuntime.jsx("div", { className: "w-224 h-96 overflow-y-auto overflow-hidden", children: jsxRuntime.jsx("ul", { className: "columns-4 gap-4", children: img.map((p, i) => {
                return jsxRuntime.jsx("li", { className: " break-inside-avoid", children: jsxRuntime.jsx(Image, { onClick: () => {
                            p.selected = !p.selected;
                            setImg([...img]);
                            onSelect(img.filter(p => p.selected).map(p => p.src));
                        }, src: p.src, selected: p.selected }) }, i);
            }) }) });
}

function ImageSelection({ onSelect, onCancel, getFiles, uploadUrl }) {
    const [images, setImages] = React.useState([]);
    const [selected, setSelected] = React.useState([]);
    const [uploadProgress, setUploadProgress] = React.useState(0);
    const [loading, setLoading] = React.useState(false);
    const [count, setCount] = React.useState(0);
    const [offset, setOffset] = React.useState(0);
    const limit = 10;
    const loadImg = React.useCallback(() => __awaiter(this, void 0, void 0, function* () {
        if (getFiles) {
            setLoading(true);
            const { results: urls, count } = yield getFiles({ limit, offset });
            setImages(urls);
            setCount(count);
            setLoading(false);
        }
    }), [offset, limit]);
    React.useEffect(() => {
        loadImg();
    }, [limit, offset, getFiles]);
    const upload = (files) => {
        if (uploadUrl) {
            let xhr = new XMLHttpRequest();
            xhr.open('POST', uploadUrl, true);
            xhr.upload.onprogress = function (e) {
                if (e.lengthComputable) {
                    setUploadProgress((e.loaded / e.total) * 100);
                }
            };
            xhr.onload = function () {
                if (this.status == 200) {
                    console.log('Upload complete');
                    loadImg();
                }
            };
            let formData = new FormData();
            formData.append('file', files[0]);
            xhr.send(formData);
        }
    };
    const uploading = React.useMemo(() => {
        return uploadProgress > 0 && uploadProgress < 100;
    }, [uploadProgress]);
    return jsxRuntime.jsxs("div", { className: "bg-gray-100 py-4 px-3 flex flex-col w-224", children: [jsxRuntime.jsx("h3", { className: "border-b pb-2 border-gray-200 text-lg", children: "Add Image" }), jsxRuntime.jsx(ImageViewer, { onSelect: (images) => { setSelected(images); }, images: images, loading: loading }), jsxRuntime.jsx(ui.Pagination, { containerClassName: 'mt-5', limit: limit, count: count, offset: offset, onPageChanged: (i) => { setOffset((i - 1) * limit); } }), uploadUrl && jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx("button", { className: "cursor-pointer underline text-blue-400 my-5", disabled: uploading, onClick: () => { var _a; return (_a = document.getElementById("fileInput")) === null || _a === void 0 ? void 0 : _a.click(); }, children: uploading ? `${uploadProgress.toFixed(0)} %` : 'Upload' }), jsxRuntime.jsx("div", { className: "h-0 w-0 overflow-hidden", children: jsxRuntime.jsx("input", { type: "file", id: "fileInput", name: "fileInput", onChange: (e) => {
                                var _a, _b, _c;
                                if (((_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.files) && ((_b = e === null || e === void 0 ? void 0 : e.target) === null || _b === void 0 ? void 0 : _b.files[0])) {
                                    upload((_c = e === null || e === void 0 ? void 0 : e.target) === null || _c === void 0 ? void 0 : _c.files);
                                }
                            } }) })] }), jsxRuntime.jsxs("div", { className: "flex flex-row justify-end gap-2 items-center my-2", children: [jsxRuntime.jsx("div", { className: "text-gray-400 cursor-pointer", onClick: () => {
                            onCancel();
                        }, children: "Cancel" }), jsxRuntime.jsx(ui.Button, { onClick: () => {
                            onSelect(selected);
                        }, children: "Confirm" })] })] });
}

function AddUrl({ onCancel, onConfirm, title }) {
    const [url, setUrl] = React__default["default"].useState("");
    return (jsxRuntime.jsxs("div", { className: "bg-gray-100 py-4 px-3 flex flex-col", children: [jsxRuntime.jsx("h3", { className: "border-b pb-2 border-gray-200 text-lg", children: title }), jsxRuntime.jsx("div", { className: "flex flex-col py-4 gap-2", children: jsxRuntime.jsx(ui.FormInput, { label: "Url:", placeholder: "Enter url", onChange: (v) => setUrl(v) }) }), jsxRuntime.jsxs("div", { className: "flex flex-row justify-end gap-2 items-center", children: [jsxRuntime.jsx("div", { onClick: () => {
                            onCancel();
                        }, className: "text-gray-400 cursor-pointer", children: "Cancel" }), jsxRuntime.jsx(ui.Button, { disabled: !url, onClick: () => {
                            onConfirm(url);
                        }, children: "Confirm" })] })] }));
}

const LowPriority = 1;
const supportedBlockTypes = new Set([
    "paragraph",
    "quote",
    "code",
    // "h1",
    "h2",
    "ul",
    "ol"
]);
const blockTypeToBlockName = {
    code: "Code Block",
    h1: "Large Heading",
    h2: "Small Heading",
    h3: "Heading",
    h4: "Heading",
    h5: "Heading",
    ol: "Numbered List",
    paragraph: "Normal",
    quote: "Quote",
    ul: "Bulleted List"
};
function Divider() {
    return jsxRuntime.jsx("div", { className: "divider" });
}
function positionEditorElement(editor, rect) {
    if (rect === null) {
        editor.style.opacity = "0";
        editor.style.top = "-1000px";
        editor.style.left = "-1000px";
    }
    else {
        editor.style.opacity = "1";
        editor.style.top = `${rect.top + rect.height + window.pageYOffset + 10}px`;
        editor.style.left = `${rect.left + window.pageXOffset - editor.offsetWidth / 2 + rect.width / 2}px`;
    }
}
function FloatingLinkEditor({ editor }) {
    const editorRef = React.useRef(null);
    const inputRef = React.useRef(null);
    const mouseDownRef = React.useRef(false);
    const [linkUrl, setLinkUrl] = React.useState("");
    const [isEditMode, setEditMode] = React.useState(false);
    const [lastSelection, setLastSelection] = React.useState(null);
    const updateLinkEditor = React.useCallback(() => {
        const selection = lexical.$getSelection();
        if (lexical.$isRangeSelection(selection)) {
            const node = getSelectedNode(selection);
            const parent = node.getParent();
            if (link.$isLinkNode(parent)) {
                setLinkUrl(parent.getURL());
            }
            else if (link.$isLinkNode(node)) {
                setLinkUrl(node.getURL());
            }
            else {
                setLinkUrl("");
            }
        }
        const editorElem = editorRef.current;
        const nativeSelection = window.getSelection();
        const activeElement = document.activeElement;
        if (editorElem === null) {
            return;
        }
        const rootElement = editor.getRootElement();
        if (nativeSelection &&
            selection !== null &&
            !nativeSelection.isCollapsed &&
            rootElement !== null &&
            rootElement.contains(nativeSelection.anchorNode)) {
            const domRange = nativeSelection.getRangeAt(0);
            let rect;
            if (nativeSelection.anchorNode === rootElement) {
                let inner = rootElement;
                while (inner.firstElementChild != null) {
                    inner = inner.firstElementChild;
                }
                rect = inner.getBoundingClientRect();
            }
            else {
                rect = domRange.getBoundingClientRect();
            }
            if (!mouseDownRef.current) {
                positionEditorElement(editorElem, rect);
            }
            setLastSelection(selection);
        }
        else if (!activeElement || activeElement.className !== "link-input") {
            positionEditorElement(editorElem, null);
            setLastSelection(null);
            setEditMode(false);
            setLinkUrl("");
        }
        return true;
    }, [editor]);
    React.useEffect(() => {
        return utils.mergeRegister(editor.registerUpdateListener(({ editorState }) => {
            editorState.read(() => {
                updateLinkEditor();
            });
        }), editor.registerCommand(lexical.SELECTION_CHANGE_COMMAND, () => {
            updateLinkEditor();
            return true;
        }, LowPriority));
    }, [editor, updateLinkEditor]);
    React.useEffect(() => {
        editor.getEditorState().read(() => {
            updateLinkEditor();
        });
    }, [editor, updateLinkEditor]);
    React.useEffect(() => {
        if (isEditMode && inputRef.current) {
            inputRef.current.focus();
        }
    }, [isEditMode]);
    return (jsxRuntime.jsx("div", { ref: editorRef, className: "link-editor", children: isEditMode ? (jsxRuntime.jsx("input", { ref: inputRef, className: "link-input", value: linkUrl, onChange: (event) => {
                setLinkUrl(event.target.value);
            }, onKeyDown: (event) => {
                if (event.key === "Enter") {
                    event.preventDefault();
                    if (lastSelection !== null) {
                        if (linkUrl !== "") {
                            editor.dispatchCommand(link.TOGGLE_LINK_COMMAND, linkUrl);
                        }
                        setEditMode(false);
                    }
                }
                else if (event.key === "Escape") {
                    event.preventDefault();
                    setEditMode(false);
                }
            } })) : (jsxRuntime.jsx(jsxRuntime.Fragment, { children: jsxRuntime.jsxs("div", { className: "link-input", children: [jsxRuntime.jsx("a", { href: linkUrl, target: "_blank", rel: "noopener noreferrer", children: linkUrl }), jsxRuntime.jsx("div", { className: "link-edit", role: "button", tabIndex: 0, onMouseDown: (event) => event.preventDefault(), onClick: () => {
                            setEditMode(true);
                        } })] }) })) }));
}
function Select({ onChange, className, options, value }) {
    return (jsxRuntime.jsxs("select", { className: className, onChange: onChange, value: value, children: [jsxRuntime.jsx("option", { hidden: true, value: "" }), options.map((option) => (jsxRuntime.jsx("option", { value: option, children: option }, option)))] }));
}
function getSelectedNode(selection$1) {
    const anchor = selection$1.anchor;
    const focus = selection$1.focus;
    const anchorNode = selection$1.anchor.getNode();
    const focusNode = selection$1.focus.getNode();
    if (anchorNode === focusNode) {
        return anchorNode;
    }
    const isBackward = selection$1.isBackward();
    if (isBackward) {
        return selection.$isAtNodeEnd(focus) ? anchorNode : focusNode;
    }
    else {
        return selection.$isAtNodeEnd(anchor) ? focusNode : anchorNode;
    }
}
function BlockOptionsDropdownList({ editor, blockType, toolbarRef, setShowBlockOptionsDropDown }) {
    const dropDownRef = React.useRef(null);
    React.useEffect(() => {
        const toolbar = toolbarRef.current;
        const dropDown = dropDownRef.current;
        if (toolbar !== null && dropDown !== null) {
            const { top, left } = toolbar.getBoundingClientRect();
            dropDown.style.top = `${top + 40}px`;
            dropDown.style.left = `${left}px`;
        }
    }, [dropDownRef, toolbarRef]);
    React.useEffect(() => {
        const dropDown = dropDownRef.current;
        const toolbar = toolbarRef.current;
        if (dropDown !== null && toolbar !== null) {
            const handle = (event) => {
                const target = event.target;
                if (!dropDown.contains(target) && !toolbar.contains(target)) {
                    setShowBlockOptionsDropDown(false);
                }
            };
            document.addEventListener("click", handle);
            return () => {
                document.removeEventListener("click", handle);
            };
        }
    }, [dropDownRef, setShowBlockOptionsDropDown, toolbarRef]);
    const formatParagraph = () => {
        if (blockType !== "paragraph") {
            editor.update(() => {
                const selection$1 = lexical.$getSelection();
                if (lexical.$isRangeSelection(selection$1)) {
                    selection.$wrapNodes(selection$1, () => lexical.$createParagraphNode());
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatSmallHeading = () => {
        if (blockType !== "h2") {
            editor.update(() => {
                const selection$1 = lexical.$getSelection();
                if (lexical.$isRangeSelection(selection$1)) {
                    selection.$wrapNodes(selection$1, () => richText.$createHeadingNode("h2"));
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatBulletList = () => {
        if (blockType !== "ul") {
            editor.dispatchCommand(list.INSERT_UNORDERED_LIST_COMMAND);
        }
        else {
            editor.dispatchCommand(list.REMOVE_LIST_COMMAND);
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatNumberedList = () => {
        if (blockType !== "ol") {
            editor.dispatchCommand(list.INSERT_ORDERED_LIST_COMMAND);
        }
        else {
            editor.dispatchCommand(list.REMOVE_LIST_COMMAND);
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatQuote = () => {
        if (blockType !== "quote") {
            editor.update(() => {
                const selection$1 = lexical.$getSelection();
                if (lexical.$isRangeSelection(selection$1)) {
                    selection.$wrapNodes(selection$1, () => richText.$createQuoteNode());
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatCode = () => {
        if (blockType !== "code") {
            editor.update(() => {
                const selection$1 = lexical.$getSelection();
                if (lexical.$isRangeSelection(selection$1)) {
                    selection.$wrapNodes(selection$1, () => code.$createCodeNode());
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    return (jsxRuntime.jsxs("div", { className: "dropdown", ref: dropDownRef, children: [jsxRuntime.jsxs("button", { className: "item", onClick: formatParagraph, children: [jsxRuntime.jsx("span", { className: "icon paragraph" }), jsxRuntime.jsx("span", { className: "text", children: "Normal" }), blockType === "paragraph" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatSmallHeading, children: [jsxRuntime.jsx("span", { className: "icon small-heading" }), jsxRuntime.jsx("span", { className: "text", children: "Small Heading" }), blockType === "h2" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatBulletList, children: [jsxRuntime.jsx("span", { className: "icon bullet-list" }), jsxRuntime.jsx("span", { className: "text", children: "Bullet List" }), blockType === "ul" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatNumberedList, children: [jsxRuntime.jsx("span", { className: "icon numbered-list" }), jsxRuntime.jsx("span", { className: "text", children: "Numbered List" }), blockType === "ol" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatQuote, children: [jsxRuntime.jsx("span", { className: "icon quote" }), jsxRuntime.jsx("span", { className: "text", children: "Quote" }), blockType === "quote" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatCode, children: [jsxRuntime.jsx("span", { className: "icon code" }), jsxRuntime.jsx("span", { className: "text", children: "Code Block" }), blockType === "code" && jsxRuntime.jsx("span", { className: "active" })] })] }));
}
function ToolbarPlugin({ uploadImageUrl: uploadUrl, getImages }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    const toolbarRef = React.useRef(null);
    const [canUndo, setCanUndo] = React.useState(false);
    const [canRedo, setCanRedo] = React.useState(false);
    const [blockType, setBlockType] = React.useState("paragraph");
    const [selectedElementKey, setSelectedElementKey] = React.useState(null);
    const [showBlockOptionsDropDown, setShowBlockOptionsDropDown] = React.useState(false);
    const [codeLanguage, setCodeLanguage] = React.useState("");
    const [isRTL, setIsRTL] = React.useState(false);
    const [isLink, setIsLink] = React.useState(false);
    const [isBold, setIsBold] = React.useState(false);
    const [isItalic, setIsItalic] = React.useState(false);
    const [isUnderline, setIsUnderline] = React.useState(false);
    const [isStrikethrough, setIsStrikethrough] = React.useState(false);
    const [isCode, setIsCode] = React.useState(false);
    const updateToolbar = React.useCallback(() => {
        const selection$1 = lexical.$getSelection();
        if (lexical.$isRangeSelection(selection$1)) {
            const anchorNode = selection$1.anchor.getNode();
            const element = anchorNode.getKey() === "root"
                ? anchorNode
                : anchorNode.getTopLevelElementOrThrow();
            const elementKey = element.getKey();
            const elementDOM = editor.getElementByKey(elementKey);
            if (elementDOM !== null) {
                setSelectedElementKey(elementKey);
                if (list.$isListNode(element)) {
                    const parentList = utils.$getNearestNodeOfType(anchorNode, list.ListNode);
                    const type = parentList ? parentList.getTag() : element.getTag();
                    setBlockType(type);
                }
                else {
                    const type = richText.$isHeadingNode(element)
                        ? element.getTag()
                        : element.getType();
                    setBlockType(type);
                    if (code.$isCodeNode(element)) {
                        setCodeLanguage(element.getLanguage() || code.getDefaultCodeLanguage());
                    }
                }
            }
            // Update text format
            setIsBold(selection$1.hasFormat("bold"));
            setIsItalic(selection$1.hasFormat("italic"));
            setIsUnderline(selection$1.hasFormat("underline"));
            setIsStrikethrough(selection$1.hasFormat("strikethrough"));
            setIsCode(selection$1.hasFormat("code"));
            setIsRTL(selection.$isParentElementRTL(selection$1));
            // Update links
            const node = getSelectedNode(selection$1);
            const parent = node.getParent();
            if (link.$isLinkNode(parent) || link.$isLinkNode(node)) {
                setIsLink(true);
            }
            else {
                setIsLink(false);
            }
        }
    }, [editor]);
    React.useEffect(() => {
        return utils.mergeRegister(editor.registerUpdateListener(({ editorState }) => {
            editorState.read(() => {
                updateToolbar();
            });
        }), editor.registerCommand(lexical.SELECTION_CHANGE_COMMAND, (_payload, newEditor) => {
            updateToolbar();
            return false;
        }, LowPriority), editor.registerCommand(lexical.CAN_UNDO_COMMAND, (payload) => {
            setCanUndo(payload);
            return false;
        }, LowPriority), editor.registerCommand(lexical.CAN_REDO_COMMAND, (payload) => {
            setCanRedo(payload);
            return false;
        }, LowPriority));
    }, [editor, updateToolbar]);
    const [video, setVideoActive] = React__default["default"].useState(false);
    const [imgActive, setImgActive] = React__default["default"].useState(false);
    const codeLanguges = React.useMemo(() => code.getCodeLanguages(), []);
    const onCodeLanguageSelect = React.useCallback((e) => {
        editor.update(() => {
            if (selectedElementKey !== null) {
                const node = lexical.$getNodeByKey(selectedElementKey);
                if (code.$isCodeNode(node)) {
                    node.setLanguage(e.target.value);
                }
            }
        });
    }, [editor, selectedElementKey]);
    const insertLink = React.useCallback(() => {
        if (!isLink) {
            editor.dispatchCommand(link.TOGGLE_LINK_COMMAND, "https://");
        }
        else {
            editor.dispatchCommand(link.TOGGLE_LINK_COMMAND, null);
        }
    }, [editor, isLink]);
    const insertImage = React.useCallback((url) => {
        // Executing command defined in a plugin
        editor.dispatchCommand(INSERT_IMAGE_COMMAND, url);
    }, [editor]);
    const insertVideo = (url) => {
        console.log(insertVideo, url);
        // Executing command defined in a plugin
        editor.dispatchCommand(INSERT_VIDEO_COMMAND, url);
    };
    return (jsxRuntime.jsxs("div", { className: "toolbar", ref: toolbarRef, children: [jsxRuntime.jsx("button", { disabled: !canUndo, onClick: () => {
                    editor.dispatchCommand(lexical.UNDO_COMMAND);
                }, className: "toolbar-item spaced", "aria-label": "Undo", children: jsxRuntime.jsx("i", { className: "format undo" }) }), jsxRuntime.jsx("button", { disabled: !canRedo, onClick: () => {
                    editor.dispatchCommand(lexical.REDO_COMMAND);
                }, className: "toolbar-item", "aria-label": "Redo", children: jsxRuntime.jsx("i", { className: "format redo" }) }), jsxRuntime.jsx(Divider, {}), supportedBlockTypes.has(blockType) && (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsxs("button", { className: "toolbar-item block-controls", onClick: () => setShowBlockOptionsDropDown(!showBlockOptionsDropDown), "aria-label": "Formatting Options", children: [jsxRuntime.jsx("span", { className: "icon block-type " + blockType }), jsxRuntime.jsx("span", { className: "text", children: blockTypeToBlockName[blockType] }), jsxRuntime.jsx("i", { className: "chevron-down" })] }), showBlockOptionsDropDown &&
                        reactDom.createPortal(jsxRuntime.jsx(BlockOptionsDropdownList, { editor: editor, blockType: blockType, toolbarRef: toolbarRef, setShowBlockOptionsDropDown: setShowBlockOptionsDropDown }), document.body), jsxRuntime.jsx(Divider, {})] })), blockType === "code" ? (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx(Select, { className: "toolbar-item code-language", onChange: onCodeLanguageSelect, options: codeLanguges, value: codeLanguage }), jsxRuntime.jsx("i", { className: "chevron-down inside" })] })) : (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_TEXT_COMMAND, "bold");
                        }, className: "toolbar-item spaced " + (isBold ? "active" : ""), "aria-label": "Format Bold", children: jsxRuntime.jsx("i", { className: "format bold" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_TEXT_COMMAND, "italic");
                        }, className: "toolbar-item spaced " + (isItalic ? "active" : ""), "aria-label": "Format Italics", children: jsxRuntime.jsx("i", { className: "format italic" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_TEXT_COMMAND, "underline");
                        }, className: "toolbar-item spaced " + (isUnderline ? "active" : ""), "aria-label": "Format Underline", children: jsxRuntime.jsx("i", { className: "format underline" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_TEXT_COMMAND, "strikethrough");
                        }, className: "toolbar-item spaced " + (isStrikethrough ? "active" : ""), "aria-label": "Format Strikethrough", children: jsxRuntime.jsx("i", { className: "format strikethrough" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_TEXT_COMMAND, "code");
                        }, className: "toolbar-item spaced " + (isCode ? "active" : ""), "aria-label": "Insert Code", children: jsxRuntime.jsx("i", { className: "format code" }) }), jsxRuntime.jsx("button", { onClick: insertLink, className: "toolbar-item spaced " + (isLink ? "active" : ""), "aria-label": "Insert Link", children: jsxRuntime.jsx("i", { className: "format link" }) }), isLink &&
                        reactDom.createPortal(jsxRuntime.jsx(FloatingLinkEditor, { editor: editor }), document.body), jsxRuntime.jsx(Divider, {}), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_ELEMENT_COMMAND, "left");
                        }, className: "toolbar-item spaced", "aria-label": "Left Align", children: jsxRuntime.jsx("i", { className: "format left-align" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_ELEMENT_COMMAND, "center");
                        }, className: "toolbar-item spaced", "aria-label": "Center Align", children: jsxRuntime.jsx("i", { className: "format center-align" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_ELEMENT_COMMAND, "right");
                        }, className: "toolbar-item spaced", "aria-label": "Right Align", children: jsxRuntime.jsx("i", { className: "format right-align" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(lexical.FORMAT_ELEMENT_COMMAND, "justify");
                        }, className: "toolbar-item", "aria-label": "Justify Align", children: jsxRuntime.jsx("i", { className: "format justify-align" }) }), jsxRuntime.jsx(Divider, {}), jsxRuntime.jsx("button", { onClick: () => {
                            setImgActive(true);
                        }, className: "toolbar-item spaced", "aria-label": "Image", children: jsxRuntime.jsx("i", { className: "format image" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            setVideoActive(true);
                        }, className: "toolbar-item spaced", "aria-label": "Video", children: jsxRuntime.jsx("i", { className: "format video" }) })] })), jsxRuntime.jsx(ui.Modal, { active: video, setActive: setVideoActive, children: jsxRuntime.jsx(AddUrl, { title: "Add Video", onCancel: () => setVideoActive(false), onConfirm: (url => {
                        setVideoActive(false);
                        insertVideo(url);
                    }) }) }), jsxRuntime.jsx(ui.Modal, { className: "w-224", active: imgActive, setActive: setImgActive, children: !!getImages ? jsxRuntime.jsx(ImageSelection, { uploadUrl: uploadUrl, onCancel: () => {
                        setImgActive(false);
                    }, onSelect: (images) => {
                        images.map(p => insertImage(p));
                        setImgActive(false);
                    }, getFiles: getImages }) : jsxRuntime.jsx(AddUrl, { title: "Add Image", onCancel: () => setVideoActive(false), onConfirm: (url => {
                        setImgActive(false);
                        insertImage(url);
                    }) }) })] }));
}

function getElementNodesInSelection(selection) {
    const nodesInSelection = selection.getNodes();
    if (nodesInSelection.length === 0) {
        return new Set([
            selection.anchor.getNode().getParentOrThrow(),
            selection.focus.getNode().getParentOrThrow()
        ]);
    }
    return new Set(nodesInSelection.map((n) => (lexical.$isElementNode(n) ? n : n.getParentOrThrow())));
}
function isIndentPermitted(maxDepth) {
    const selection = lexical.$getSelection();
    if (!lexical.$isRangeSelection(selection)) {
        return false;
    }
    const elementNodesInSelection = getElementNodesInSelection(selection);
    let totalDepth = 0;
    for (const elementNode of elementNodesInSelection) {
        if (list.$isListNode(elementNode)) {
            totalDepth = Math.max(list.$getListDepth(elementNode) + 1, totalDepth);
        }
        else if (list.$isListItemNode(elementNode)) {
            const parent = elementNode.getParent();
            if (!list.$isListNode(parent)) {
                throw new Error("ListMaxIndentLevelPlugin: A ListItemNode must have a ListNode for a parent.");
            }
            totalDepth = Math.max(list.$getListDepth(parent) + 1, totalDepth);
        }
    }
    return totalDepth <= maxDepth;
}
function ListMaxIndentLevelPlugin({ maxDepth }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        return editor.registerCommand(lexical.INDENT_CONTENT_COMMAND, () => !isIndentPermitted(maxDepth !== null && maxDepth !== void 0 ? maxDepth : 7), lexical.COMMAND_PRIORITY_HIGH);
    }, [editor, maxDepth]);
    return null;
}

function CodeHighlightPlugin() {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        return code.registerCodeHighlighting(editor);
    }, [editor]);
    return null;
}

const URL_MATCHER = /((https?:\/\/(www\.)?)|(www\.))[-a-zA-Z0-9@:%._+~#=]{1,256}\.[a-zA-Z0-9()]{1,6}\b([-a-zA-Z0-9()@:%_+.~#?&//=]*)/;
const EMAIL_MATCHER = /(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))/;
const MATCHERS = [
    (text) => {
        const match = URL_MATCHER.exec(text);
        return (match && {
            index: match.index,
            length: match[0].length,
            text: match[0],
            url: match[0]
        });
    },
    (text) => {
        const match = EMAIL_MATCHER.exec(text);
        return (match && {
            index: match.index,
            length: match[0].length,
            text: match[0],
            url: `mailto:${match[0]}`
        });
    }
];
function PlaygroundAutoLinkPlugin() {
    return jsxRuntime.jsx(LexicalAutoLinkPlugin.AutoLinkPlugin, { matchers: MATCHERS });
}

function InitialWithHtmlPlugin({ html: initHtml = '' }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        if (initHtml) {
            const parser = new DOMParser();
            const dom = parser.parseFromString(initHtml, 'text/html');
            editor.update(() => {
                const nodes = html.$generateNodesFromDOM(editor, dom);
                lexical.$getRoot().select();
                lexical.$insertNodes(nodes);
            });
        }
    }, [editor, initHtml]);
    return null;
}

function HeaderPlugin({ placeholder = 'Enter a title...' }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    const [header, setHeder] = React.useState('');
    const [value, setValue] = React.useState('');
    React.useLayoutEffect(() => {
        return editor.registerUpdateListener(() => {
            if (editor) {
                editor.update(() => {
                    const firstNode = lexical.$getRoot().getChildAtIndex(0);
                    if (firstNode && firstNode.__tag === 'h1') {
                        console.log(firstNode.getTextContent());
                        setValue(firstNode.getTextContent());
                    }
                });
            }
        });
    }, [editor]);
    React.useEffect(() => {
        if (editor) {
            if (header) {
                const parser = new DOMParser();
                const dom = parser.parseFromString(`<h1 class=\"editor-heading-h1\"><span>${header}</span></h1>`, 'text/html');
                editor.update(() => {
                    const nodes = html.$generateNodesFromDOM(editor, dom);
                    const firstNode = lexical.$getRoot().getChildAtIndex(0);
                    if (firstNode) {
                        firstNode.insertBefore(nodes[0]);
                        if (firstNode.__tag === 'h1') {
                            firstNode.remove();
                        }
                    }
                });
            }
        }
    }, [editor, header]);
    return jsxRuntime.jsx("input", { type: "text", placeholder: placeholder, value: value, onChange: (e) => { setValue(e.currentTarget.value); }, onBlur: () => setHeder(value), autoFocus: true, className: "text-4xl h-24 w-full border-b mb-4 outline-0 px-2" });
}

function VideoPlugin() {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        // Similar with command listener, which returns unlisten callback
        const removeListener = editor.registerCommand(INSERT_VIDEO_COMMAND, (payload) => {
            // Adding custom command that will be handled by this plugin
            editor.update(() => {
                lexical.$insertNodes([$createVideoNode(payload)], true);
            });
            // Returning true indicates that command is handled and no further propagation is required
            return true;
        }, 0);
        return () => {
            removeListener();
        };
    }, [editor]);
    return null;
}

function ImagePlugin() {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        // Similar with command listener, which returns unlisten callback
        const removeListener = editor.registerCommand(INSERT_IMAGE_COMMAND, (payload) => {
            // Adding custom command that will be handled by this plugin
            editor.update(() => {
                lexical.$insertNodes([$createImageNode(payload)], true);
            });
            // Returning true indicates that command is handled and no further propagation is required
            return true;
        }, 0);
        return () => {
            removeListener();
        };
    }, [editor]);
    return null;
}

const domain = `https://editor.cpchain.io`;
const defaultUrl = domain + `/graphql`;
const editorUploadImageUrl = `${domain}/upload`;
function graphqlQuery(query, opts) {
    return __awaiter(this, void 0, void 0, function* () {
        const res = yield fetch((opts === null || opts === void 0 ? void 0 : opts.server) || defaultUrl, {
            method: 'POST',
            headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({
                query
            })
        });
        const data = yield res.json();
        return data.data;
    });
}
function getFiles({ limit, offset }) {
    return __awaiter(this, void 0, void 0, function* () {
        const r = yield graphqlQuery(`query { 
        files(limit:${limit},offset:${offset}, tags:["image"], excludeTags:["svgr/webpack"]) {
            count,
            results {
              originPath,
              minPath,
              tags,
            }
          }
      } `);
        return r.files;
    });
}
function getEditorImages({ limit, offset }) {
    return __awaiter(this, void 0, void 0, function* () {
        const r = yield getFiles({ limit, offset });
        const urls = r.results.map(p => domain + p.originPath);
        return { count: r.count, results: urls };
    });
}

function DefaultPlaceholder() {
    return jsxRuntime.jsx("div", { className: "editor-placeholder", children: "Enter some text..." });
}
const editorConfig = {
    // The editor theme
    theme: exampleTheme,
    // Handling of errors during update
    onError(error) {
        throw error;
    },
    // Any custom nodes go here
    nodes: [
        richText.HeadingNode,
        list.ListNode,
        list.ListItemNode,
        richText.QuoteNode,
        code.CodeNode,
        code.CodeHighlightNode,
        table.TableNode,
        table.TableCellNode,
        table.TableRowNode,
        link.AutoLinkNode,
        link.LinkNode,
        VideoNode,
        ImageNode
    ]
};
function Editor({ getImages = getEditorImages, titlePlaceHolder, initialHtml: initHtml, onChange, Placeholder = DefaultPlaceholder, uploadImageUrl = editorUploadImageUrl }) {
    const onEditorChange = React.useCallback((editorState, editor) => {
        editorState.read(() => {
            const htmlString = html.$generateHtmlFromNodes(editor);
            if (htmlString !== initHtml && htmlString !== '<p class="editor-paragraph"><br></p>') {
                const firstNode = lexical.$getRoot().getChildAtIndex(0);
                let header = '';
                if (firstNode && firstNode.__tag === 'h1') {
                    header = firstNode.getTextContent();
                }
                onChange({ html: htmlString, title: header });
            }
        });
    }, [initHtml]);
    return (jsxRuntime.jsx(LexicalComposer.LexicalComposer, { initialConfig: editorConfig, children: jsxRuntime.jsxs("div", { className: "editor-container shadow-xl", children: [jsxRuntime.jsx(HeaderPlugin, { placeholder: titlePlaceHolder }), jsxRuntime.jsx(ToolbarPlugin, { getImages: getImages, uploadImageUrl: uploadImageUrl }), jsxRuntime.jsxs("div", { className: "editor-inner", children: [jsxRuntime.jsx(LexicalRichTextPlugin.RichTextPlugin, { contentEditable: jsxRuntime.jsx(LexicalContentEditable.ContentEditable, { className: "editor-input" }), placeholder: jsxRuntime.jsx(Placeholder, {}), ErrorBoundary: LexicalErrorBoundary__default["default"] }), jsxRuntime.jsx(LexicalOnChangePlugin.OnChangePlugin, { onChange: onEditorChange }), jsxRuntime.jsx(InitialWithHtmlPlugin, { html: initHtml }), jsxRuntime.jsx(LexicalHistoryPlugin.HistoryPlugin, {}), jsxRuntime.jsx(LexicalAutoFocusPlugin.AutoFocusPlugin, {}), jsxRuntime.jsx(CodeHighlightPlugin, {}), jsxRuntime.jsx(LexicalListPlugin.ListPlugin, {}), jsxRuntime.jsx(LexicalLinkPlugin.LinkPlugin, {}), jsxRuntime.jsx(PlaygroundAutoLinkPlugin, {}), jsxRuntime.jsx(ListMaxIndentLevelPlugin, { maxDepth: 7 }), jsxRuntime.jsx(LexicalMarkdownShortcutPlugin.MarkdownShortcutPlugin, { transformers: markdown.TRANSFORMERS }), jsxRuntime.jsx(VideoPlugin, {}), jsxRuntime.jsx(ImagePlugin, {})] })] }) }));
}

exports.Editor = Editor;
